'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _boom = require('boom');

var _boom2 = _interopRequireDefault(_boom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = (permission, options = {
  getSubject: req => req.user || {},
  getObject: () => {}
}) => (() => {
  var _ref = _asyncToGenerator(function* (req, res, next) {
    const subject = options.getSubject(req);
    const object = options.getObject(req);
    const { permissionsManager } = req.app.modules.get('oors.security');

    try {
      const isAllowed = yield permissionsManager.can({
        subject,
        permission,
        object
      });

      if (!isAllowed) {
        throw _boom2.default.unauthorized(`Missing "${permission}" permission!`);
      }

      next();
    } catch (err) {
      next(err);
    }
  });

  return function (_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
})();